#import  <objc/Object.h>
#import  "common.h"

@interface ImageOpr:Object

- doRotateFlipClip:(int)op to:(int)angle;
- setRandom:(float)freq :(float)mag;
- (BOOL)checkCommonInfo:(const commonInfo *)cinf filename:(const char *)fn;
- keyParentWindow:(int)op;

@end


@interface ImageOpr (Mono)

- monochrome:(int)op tone:(const unsigned char *)tone method:(int)tag;
- brightness:(const unsigned char *)tone;

@end


@interface ImageOpr (Edge)

- enhanceWith:(float)degree;
- embossWith:(float)degree and:(float)bright;
- posterizeWith:(float)diff and:(float)ctrl;

@end


@interface ImageOpr (SFrame)

- softFrame:(float)ratio shape:(int)shape color:(int *)color;

@end


@interface ImageOpr (ColorReplace)

- colorChange:(int *)origclr to:(int *)newclr
	with:(float)comparison uniformly:(BOOL)uniform area:(BOOL)outside;

@end

@interface ImageOpr (ColorToneCtrl)

- colorToneEnhance:(const float *)ratio;

@end


@interface ImageOpr (ReduceColor)

- reduceUsing: (int)tag;	/* by Median Cut Method */
- (BOOL)needReduce:(const char *)fn colors:(int)cnum ask:(BOOL)ask;

@end


@interface ImageOpr (ColorHalf)

- colorHalftoneWith:(int)colnum method:(int)tag;
	/* by Dither or MDA (Mean Density Approximation Method) */ 

@end


@interface ImageOpr (CutDownBits)

- cutDownBitsTo:(int)bits;

@end


@interface ImageOpr (Newmap)

- newBitmap: sender;
- EPSResize: sender;

@end
