#import <objc/Object.h>
#import <appkit/Responder.h>

@class ToyWin, NXImage;

@interface TVController:Object
{
	id	printInfo;
	id	menuToFront;
	id	menuClear;
	id	preference;
	id	imageOpCtr;
	id	backgCtr;
	id	messagePanel;
	id	messageText;
}

- appDidInit:sender;
- (int)getFTypeID: (const char *)aType;
- drawFile: (const char *)fn :(const char *)aType;
- (NXStream *)openStreamFromFile: (const char *)fn :(const char *)aType;
- openFile:sender;
- openPasteBoard:sender;
- autoDisplay:sender;
- (int)app:sender openFile:(const char *)filename type:(const char *)aType;
- (BOOL)appAcceptsAnotherFile:sender;
- messageDisplay:(const char *)msg;

/* To receive services, implement these methods (delegate of NXApp) */
- validRequestorForSendType:(NXAtom)sendType andReturnType:(NXAtom)returnType;
- readSelectionFromPasteboard:pb;

@end

@interface TVController (WindowManager)

- newWindow: (ToyWin *)win;
- checkWindow: (ToyWin *)win delete:(BOOL)delflag;
- deleteAllWindow: sender;
- showAllWindow: sender;
- keyWindow;
- (BOOL)isOpened: (const char *)newfile;
- (BOOL)isOpenedID: (ToyWin *)win;

- print: sender;
- saveAs: sender;

- attraction: sender;	// Info.Panel attraction

@end


@interface TVController (BackgroundManager)

- initWallpaper;
- readWallpaperSetting: sender;
- cleanBackground: sender;
- backgMenuEnabled:(BOOL)flag;
- makeFront: sender;
- backWinFront: (BOOL)flag;
- makeBackground: sender;

@end


@interface TVController (PBService)

- convertToTIFF:pb userData:(const char *)userData error:(char **)errorMessage;

@end


extern TVController *theController;
