#import  <objc/Object.h>
#import  <appkit/View.h>
#import  "common.h"

@class NXImage, NXImageRep, TextField, PrefControl;

@interface ToyView: View
{
	NXImage		*image;
	NXSize		origSize;
	NXSize		curSize;
	float		scaleFactor;
	float		backgray;
	unsigned char	*rawmap;
	commonInfo	*comInfo;
	NXRect		selectRect;
	TextField	*commText;
}

- initFromFile:(const char *)filename;
- initFromStream:(NXStream *)stream;
- initDataPlanes:(unsigned char **)planes info:(commonInfo *)cinf;
- setCommText: (TextField *)text;
- (NXSize *)originalSize;
- (NXSize *)resize: (float)factor;
- free;
- (NXImage *)image;
- (commonInfo *)commonInfo;
- (float)scaleFactor;
- (NXRect *)selectedRect;
- (NXRect *)selectedScaledRect;

- beginPrologueBBox:(const NXRect *)boundingBox
	creationDate:(const char *)dateCreated
	createdBy:(const char *)anApplication
	fonts:(const char *)fontNames
	forWhom:(const char *)user
	pages:(int)numPages
	title:(const char *)aTitle;	/* Overload */

@end


@interface ToyView (EventHandling)
+ cursor;
+ (BOOL)setOriginUpperLeft:(BOOL)flag;
- (BOOL)acceptsFirstResponder;
- (BOOL)acceptsFirstMouse;
- resetCursorRects;			/* Overload */

- setDraggedLine: sender;
- clearDraggedLine;
- rewriteComment;
- mouseDown:(NXEvent *)event;		/* Overload */
- selectAll:sender;			/* Overload */
- copy:sender;				/* Overload */
- drawSelf:(NXRect *)r :(int) count;	/* Overload */

@end

