#import <objc/Object.h>
#import "common.h"

@class NXImage, Window, ToyView;

#define  mini_YET	0
#define  mini_DEMINI	1
#define  mini_MINI	2

extern BOOL displayOverKeyWindowFlag;

@interface ToyWin: Object
{
	id	thiswindow;
	id	scView;
	id	commentText;
	id	parental;
	int 	operation;
	float	scaleFactor;
	char	*imageFilename;
	id	scalePanel;
	id	scaleText;
	int	miniFlag;
	BOOL	makeMapOnly;
}

+ (BOOL)displayOverKeyWindow:(BOOL)flag;
- init;
- init: parent by:(int)op;
- initMapOnly;
- free;
- (const char *)filename;
- resetFilename:(const char *)fileName;
- (Window *)window;
- toyView;
- parent;
- (int)madeby;
- reScale: sender;
- setScale: sender;
- initLocateWindow:(const char *)fileName width:(int)width height:(int)height;
- scrollProperly;

/* delegate methods */
- windowWillMiniaturize:sender toMiniwindow:miniwindow;
- windowDidDeminiaturize:sender;
- windowWillClose:sender;
- windowDidBecomeKey:sender;
- windowDidExpose:sender;
- windowDidMove:sender;

@end


@interface ToyWin (Drawing)

- (commonInfo *)drawToyWin:(const char *)fileName type:(int)type
	map:(unsigned char **)map err:(int *)err;
- drawView:(unsigned char **)map info:(commonInfo *)cinf;
- (int)drawFromFile:(const char *)fileName or:(NXStream *)stream;
- makeComment:(commonInfo *)cinf;
- makeComment:(commonInfo *)cinf from:(const commonInfo *)originfo;

@end


@interface ToyWin (Saving)

- (NXStream *)openEPSStream;
- (int)getBitmap:(unsigned char **)map info:(commonInfo **)infp;
- freeTempBitmap;
	/* freeTempBitmap must be called after getBitmap:info: */
- print: sender;

@end
